<?php

class Paygenius_Direct_Model_Payment extends Mage_Payment_Model_Method_Cc
{
    protected $_formBlockType      = 'paygenius_direct/form_cc';
    protected $_code               = 'paygenius_direct';
    protected $_canAuthorize       = true;
    protected $_canCapture         = true;
    protected $_isInitializeNeeded = false;

    public function authorize(Varien_Object $payment, $amount)
    {
        $order   = $payment->getOrder();
        $orderId = $payment->getOrder()->getIncrementId();

        $model = Mage::getModel('paygenius_common/client_paygenius')->init('paygenius_direct');
        switch ($payment->getCcType()) {
            case 'VI':
                $type = 'visa';
                break;
            case 'MC':
                $type = 'mastercard';
                break;
            case 'AE':
                $type = 'amex';
                break;
            case 'DC':
                $type = 'diners';
                break;
        }

        Mage::getSingleton('core/session')->setThreeDS(null);
        Mage::getSingleton('core/session')->setAcsURL(null);
        Mage::getSingleton('core/session')->setPAReq(null);
        Mage::getSingleton('core/session')->setMD(null);
        Mage::getSingleton('core/session')->setPGReference(null);
        Mage::getSingleton('core/session')->setPGError(null);

        $response = $model->paymentCreate(
            $payment->getCcNumber(), $payment->getCcOwner(), $payment->getCcExpYear(), $payment->getCcExpMonth(),
            $payment->getCcCid(), $type, $orderId, $order->getBaseCurrencyCode(), $amount,
            $order->getCustomerFirstname(), $order->getCustomerLastname(), $order->getCustomerEmail()
        );

        if ($response['success']) {
            if ($response['code'] == 2) {
                Mage::getSingleton('core/session')->setThreeDS(true);
                Mage::getSingleton('core/session')->setAcsURL($response ['threeDSecure']['acsUrl']);
                Mage::getSingleton('core/session')->setPAReq($response ['threeDSecure']['paReq']);
                Mage::getSingleton('core/session')->setMD($response ['threeDSecure']['transactionId']);
            } else {
                Mage::getSingleton('core/session')->setThreeDS(false);
            }
            Mage::getSingleton('core/session')->setPGReference($response['reference']);
        } else {
            Mage::getSingleton('core/session')->setPGError($this->getError($response));
        }

        return $this;
    }

    public function getOrderPlaceRedirectUrl()
    {
        if (Mage::getSingleton('core/session')->getThreeDS()) {
            return Mage::getUrl('direct/payment/confirm', array('_secure' => false));
        } else {
            $model = Mage::getModel('paygenius_common/client_paygenius')->init('paygenius_direct');

            $reference = Mage::getSingleton('core/session')->getPGReference();

            if (!empty($reference)) {
                $response = $model->execute($reference);
            }

            if ($response != null && $response['success']) {
                return Mage::getUrl('direct/payment/complete', array('_secure' => false));
            } else {
                if($response == null) {
                    $response = array('message' => Mage::getSingleton('core/session')->getPGError());
                }
                if ($lastQuoteId = Mage::getSingleton('checkout/session')->getLastQuoteId()) {
                    $quote = Mage::getModel('sales/quote')->load($lastQuoteId);
                    $quote->setIsActive(true)->save();
                }

                Mage::getSingleton('core/session')->addError($this->getError($response));
                return Mage::getUrl('checkout/cart', array('_secure' => false));
            }
        }
    }

    private function getError($result)
    {
        return isset($result['message']) ? $result['message'] : $result['error']['message'];
    }
}