<?php

class Paygenius_Direct_PaymentController extends Mage_Core_Controller_Front_Action
{

    private function getError($result)
    {
        return isset($result['message']) ? $result['message'] : $result['error']['message'];
    }

    public function verifyAction()
    {
        $model    = Mage::getModel('paygenius_common/client_paygenius')->init('paygenius_direct');
        $response = $model->confirm3DS(Mage::getSingleton('core/session')->getPGReference(),
            Mage::app()->getRequest()->getParam('PaRes'));

        if ($response['success']) {
            $this->handleSuccess();
        } else {
            $this->handleFailure($this->getError($response));
        }
    }

    public function completeAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $order   = Mage::getModel('sales/order');
        $order->loadByIncrementId($session->getLastRealOrderId());
        $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING, true, 'Gateway has authorized the payment.');

        $order->sendNewOrderEmail();
        $order->setEmailSent(true);

        $order->save();

        Mage::getSingleton('checkout/session')->unsQuoteId();

        $this->_redirect('checkout/onepage/success', array('_secure' => true));
    }

    public function confirmAction()
    {
        $this->loadLayout();
        $block = $this->getLayout()->createBlock('Paygenius_Direct_Block_Form_Redirect');
        $this->getLayout()->getBlock('content')->append($block);

        $this->renderLayout();
    }

    private function handleSuccess()
    {
        $model = Mage::getModel('paygenius_common/client_paygenius')->init('paygenius_direct');

        $response = $model->execute(Mage::getSingleton('core/session')->getPGReference());

        if ($response['success']) {
            $session = Mage::getSingleton('checkout/session');
            $order   = Mage::getModel('sales/order');
            $order->loadByIncrementId($session->getLastRealOrderId());
            $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING, true, 'Gateway has authorized the payment.');

            $order->sendNewOrderEmail();
            $order->setEmailSent(true);

            $order->save();

            Mage::getSingleton('checkout/session')->unsQuoteId();

            $this->_redirect('checkout/onepage/success', array('_secure' => true));
        } else {
            $this->handleFailure($this->getError($result));
        }
    }

    private function getOrder()
    {
        $session = Mage::getSingleton('checkout/session');
        $order   = Mage::getModel('sales/order');
        $order->loadByIncrementId($session->getLastRealOrderId());

        return $order;
    }

    private function handleFailure($message)
    {
        if ($lastQuoteId = Mage::getSingleton('checkout/session')->getLastQuoteId()) {
            $quote = Mage::getModel('sales/quote')->load($lastQuoteId);
            $quote->setIsActive(true)->save();
        }

        Mage::getSingleton('core/session')->addError($message);
        $this->_redirect('checkout/cart');
    }
}