<?php

class Paygenius_Hosted_PaymentController extends Mage_Core_Controller_Front_Action
{

    public function redirectAction()
    {
        $model = Mage::getModel('paygenius_common/client_paygenius')->init('paygenius_hosted');

        $order = $this->getOrder();

        $result = $model->redirectCreate(
            $order->getCustomerFirstname(), $order->getCustomerLastname(), $order->getGrandTotal() * 100,
            $order->getBaseCurrencyCode(), $order->getCustomerEmail(), $order->getId(),
            Mage::getStoreConfig('payment/paygenius_hosted/page'),
            Mage::getUrl('hosted/payment/return').'?reference=${reference}');

        if (!$result['success']) {
            $this->handleFailure($this->getError($result));
        } else {
            $this->_redirectUrl($result['redirectUrl']);
        }
    }

    private function getError($result)
    {
        return isset($result['message']) ? $result['message'] : $result['error']['message'];
    }

    public function returnAction()
    {
        $reference = Mage::app()->getRequest()->getParam('reference');

        $model = Mage::getModel('paygenius_common/client_paygenius')->init('paygenius_hosted');

        $payment = $model->payment($reference);

        if ($payment['status'] === 'SETTLED') {
            $this->handleSuccess();
        } else {
            $this->handleFailure($payment['message']);
        }
    }

    private function handleSuccess()
    {
        $session = Mage::getSingleton('checkout/session');
        $order   = Mage::getModel('sales/order');
        $order->loadByIncrementId($session->getLastRealOrderId());
        $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING, true, 'Gateway has authorized the payment.');

        $order->sendNewOrderEmail();
        $order->setEmailSent(true);

        $order->save();

        Mage::getSingleton('checkout/session')->unsQuoteId();

        $this->_redirect('checkout/onepage/success', array('_secure' => true));
    }

    private function getOrder()
    {
        $session = Mage::getSingleton('checkout/session');
        $order   = Mage::getModel('sales/order');
        $order->loadByIncrementId($session->getLastRealOrderId());

        return $order;
    }

    private function handleFailure($message)
    {
        if ($lastQuoteId = Mage::getSingleton('checkout/session')->getLastQuoteId()) {
            $quote = Mage::getModel('sales/quote')->load($lastQuoteId);
            $quote->setIsActive(true)->save();
        }

        Mage::getSingleton('core/session')->addError($message);
        $this->_redirect('checkout/cart');
    }
}